*******************************************************************************
v1.0 RC8
*******************************************************************************
Improvements
- Added a new placeholder to the encoder programming command line: %rom%
- Added an event plugin system which allows developers to enhance MaLa in various ways
- Added an option to use 'LED' files to overwrite the default lightning for particular games
- Added a 'lock exit' option to avoid accidental exiting
- Improved the 'copy roms to folder' in MaLaGamelist

Bugfixes
- Error creating the main game list when using a MAME 'u' versions
- Error when adding a game to another list on non mame emulators. (Not possible message)

*******************************************************************************
v1.0 RC7a
*******************************************************************************
Improvements
- Improved the MAME XML import matching the new 107 format
- Added access to the Windows Control Panel from the joystick tab to setup your connected gamecontroller
- Added an optional message box which shows the current volume and plays a sound when changing the volume with a controller
- Added support for mameinfo.dat file. Info window displays recommended games now
- Added the ability to play a video on MaLa start

Bugfixes
- Joystick not working/always disabled when using a joystick with 2 axis only
- When using cocktail/controller mapping only the detection keys (1up, 1down, start game) of the keyboard sets are working
- Volume up/down commands of joystick set are overwritten by info select command when opening the options dialog

*******************************************************************************
v1.0 RC7
*******************************************************************************
Improvements
- Added a global exception handling with logging
- Picture loading optimized, faster now when using image effects
- Scrolling acceleration can be turned on and off and the acceleration speed is configurable now.
- Complete rework of the joystick handling. No more glitches when scrolling. 
- Joystick routines can handle up to 4 axis, a pov (cooliehat) and 12 buttons for each joystick now. 
- Removed the calibration stuff, use of the windows calibration instead. 
- Configurable joystick deadzone added.
- Added the joysticks to the cocktail mapping. You can even mix keyboard and joystick sets to rotate and load a game list on controller detection.
- Added letter up, letter down, volume up, volume down, next song and previous song commands to the joystick control sets
- Added support for a second joystick
- Added the ability to display pictures (snap, marquee or control panel) instead of text in the game list display. All layout options for the game list display (diagonal, arrow, round, item height and so on) can be used with pictures too.
- Added new LED types to the LED config to light up more/other controls: joystick, trackball, dial, paddle, stick and lightgun
- Added an option to set the default vertical orientation (clockwise - counter-clockwise)
- Added tooltips to the options dialog
- Added the ability to run a LED animation sequence on various GUI events: MaLa start, MaLa exit, game start, game exit, emulator switch, list switch.
- Added an option to hide the 'All Games' list for each emulator
- MalaGamelist: Added a function to import MAME32 custom lists
- MalaAttractMode: Added a function to use a LED config from a loaded file as default config

Bugfixes
- Image effect grayscale not working on rotated screens
- Filter Master/Clone works the opposite way around ;-)
- Emulator not selected on the gamelist tab when creating a new non mame emulator
- Gamelists of emulator still displayed on the gamelist tab after deleting the emulator
- Game list still displayed after deleting it on the game list tab if the deleted game list was the selected one before opening the options dialog. Causes also an error when switching the emulator.
- MaLa freezes when adding files to the bg music playlist and shuffle is enabled
- Filter combos on filter tab not sorted

*******************************************************************************
v1.0 RC6
*******************************************************************************
Improvements
- Changed the LED triggering. Now it's possible to define more than one LED for the same button/function.
- Added an optional and configurable LED flash on game start
- Added the ability to launch external apps (e.g. start explorer when running MaLa as shell or launch a jukebox app)
- Added launch external app to the controller set
- Added the ability to launch an application on MaLa exit
- Added letter up/down commands to the controller set
- Added play buttons on the gui sound tab
- Added video display to the screensaver
- MaLa Menu now available in tree mode
- Added an option to save the last background music position on quit and restore it on start
- Added an optional and configurable LED flash on game start
- Sub directory search of mame roms optimized. Works faster now.

Bugfixes
- MalaGamelist: Error ("Zu wenig Arbeitsspeicher") when removing brackets from names on huge lists
- Index out of range error when using a tree and switching to a sub menu node in some cases
- Game list overwritten when using auto start of a game on MaLa start and the last selected game list is not the auto start game list
- Index out of range error when opening the info window and no games are in the list
- Mouse input in MaLa still active when running an emulator
- Error on next/previous game list in jukebox
- No tracking of the selecting game when using 'Auto Gamelist Switch' on orientation switch or cocktail mapping
- Switch to the 'All Games' game list when closing the options dialog with 'OK' in some cases
- Starting picture still visible when quitting an emulator
- MalaTree: Check tree function not working correctly when using a jukebox node
- MalaLayout: Absolute path for some sound files not set
- Movement sound plays twice when not using the scroll delay exception on sounds
- Background music starts from beginning when quitting a game
- Wrong game selected on next/previous emulator command when tracking of selected game is on
- Sub directory search of mame roms not working correctly

*******************************************************************************
v1.0 RC5a
*******************************************************************************
Bugfixes
• Auto layout switch not working.
• 'Game list not found' error when selecting the last emulator from the MaLa menu and the jukebox is disabled.

*******************************************************************************
v1.0 RC5
*******************************************************************************
Improvements
- Option to use a fullscreen picture instead of starting window.
- Layout: Different count of games under and over the selected game in the game list.
- Layout: Diagonal display of the game list.
- Layout: Peaked display of the game list.
- Layout: Curved display of the game list.
- Layout: Text size gradient in the game list. 

Bugfixes
- Windows not shutting down on pc power button when MaLa is running.
- MalaGamelist: Multiselect and delete in destination listbox not working (index out of bound error).
- Some more minor fixes.

*******************************************************************************
v1.0 RC4
*******************************************************************************
Improvements
- Added an aspect ratio of 1.6 (16:10) to the layout. Create scalable layouts for wide screen displays.
- MalaTree and MalaGamelist stay on top now when started via command line/from the options dialog.

Bugfixes
- Game lists are not displayed/selectable on controller mapping tab sheet.
- Game lists are not displayed/selectable in auto game list switch checkboxes.
- Joystick in Exit window not working.
- MalaGamelist: Wrong emulator name of source list displayed when starting with command line parameter.
- Button 'Delete' on game list tab not working.

*******************************************************************************
v1.0 RC3
*******************************************************************************
Improvements
- Added the ability to rotate videos in realtime. Now it is possible to display attract videos on rotated screens (90, 180, 270).
- Added the ability to execute commands before and after emulator execution.
- Added a sub folder search for rom files of non mame emulators.
- Added more placeholder for the emulator command line: rom path, parent rom name and rom extension.
- Complete rework of the 'Most played game list' handling. Now available for each emulator.
- Complete rework of the game list tab in the options dialog. Removed all editing stuff. Added a button to lauch MalaGamelist with the selected game list.
- MalaTree and MalaGamelist can be started with command line parameter: Open these apps from the options dialog to edit the tree or a game list with one click.
- Added the ability to add/remove games to/from game lists from the popup menu.
- Names of roms are temporary saved and loaded again after refreshing the main game list.
- Added the ability to update all game properties of all existing game lists for an emulator with values from the main game list.
- Added an optional message box to show the programming of a keyboard encoder.
- Added display of pre/post commands execution to the starting dialog. 
- Added emulator command line presets.
- Added a add/remove by description content (include and/or exclude) function to MaLaGamelist
- Added more GUI sounds: quit game, emu switch, attract mode/screensaver start, orientation switch.
- Added a more generic way to launch control panel viewer like CPViewer, CPMaker or Johnny5.
- Added an option to disable the internal jukebox if you want to use an external one.
- Added a function that tracks the selected game list for each emulator and the selected game of a each game list. So the last selected game list and game will be reselected when switching back to an emulator.
- Added a manifest to all applications so they use WinXP controls now.
- Added a new placeholder for text displays and lcd screens: play count.
- Added a property to the layout to hide the game list text display.
- Added more options to the definable naming: rom + 1, rom + 2, rom - 1, rom - 2. This allows to display a marquee picture list of games for example.
- Added an alternative shutdown method (shutdown.exe)
- Some more smaller improvements.

Bugfixes
- Wrong listing of game list files when using more then 10 emulators.
- Focus problem when using game start on MaLa start.
- Path of video files for other emulators not saved.
- Not possible to edit LEDs greater 16.
- Access violation in MalaLayout, MalaTree and MalaGamelist when saving a new file.
- Names of games not saved after loading a name file.

Changes
- The file format of the game lists and the emulator settings has changed.
 
*******************************************************************************
v1.0 RC2
*******************************************************************************
Improvements
- Added an option for 'smart' encoder programming. This will program the encoder only once on the first game for a new selected emulator.
- Added the 'Use pictures of master for clones' behavior to the definable images.
- Added a function to MalaLayout to change the absolute path for all images and sounds.
- Added more properties to the layout: Fonts and colors for all windows: menu, info, starting and exit.
 
Bugfixes
- GUI option 'Show videos' always disabled when closing MaLa with the exit window.
- Default images for definables not working.
- Error in MaLaGamelist when saving a game list after deleting a game from the list.
- No focus after closing an emulator (zsnesw is an example).

Changes
- Removed the message 'No games in the list. Filter enabled?' on empty game lists for quicker scolling through the lists.

*******************************************************************************
v1.0 RC1
*******************************************************************************
Improvements
- Added support for CPViewer.
- Added on option to display game controls on game start.
- Added on option to mute sound of videos in game list display.
- Complete rework of the video display:
  - New component for displaying intro videos.
  - Faster loading and display of intro videos.
  - Focus problems fixed.
- Added the ability to search rom files in subfolders.
- Complete rework of the keyboard encoder programming:
  - Command line options for the loader program.
  - Optional game based encoder configuration.
- MalaLayout: Added new quick access menus for fonts and colors. 
- New application CLViewer: Simple command line viewer for testing.

Bugfixes
- Fixed a bug which led to the fact that MalaLayout could not be started on some computer.
- LCD not initialized in v1.0 beta4.

*******************************************************************************
v1.0 beta4a
*******************************************************************************
Bugfixes
- Pictures (Snap, Marquee, CPanel) are not displayed when using shortcuts for a game list.
- Path of video files for other emulators not saved.
- Access violation on hardware detection when splash is displayed on MaLa start.
- Info window: Index out of range error on controls page
- Info window:Text not correctly cut off on history page.
- Video display: Key input not recognized in some cases (Cursor up and down).
- Video display: Video is displayed on a flipped layout/screen.

*******************************************************************************
v1.0 beta4
*******************************************************************************
Improvements
- Added desktop resolution handling. Changes the desktop resolution on various events (start, option dialog, quit). Uses resolution of fixed size layouts or specified resolution
- Some small changes for lo-res resolutions. (Windows sizes and fonts)
- Added screensaver with a picture slideshow
- Added ability to use lnk files as rom files. Use/start any windows application/pc game from a game list
- Added 32 user leds. Now all 64 leds can be user leds
- Splash rotates now to the MaLa orientation and can be used as startup timer to avoid to fast loading on some systems when MaLa is started with windows
- Added debug log file to ease error detection
- Added 'snaps' for MaLa tree nodes/items
- MaLa Layout: Added check to find controls out of scope when changing the layout size
- MaLa Layout: New menu layout
- MaLa Gamelist: Added functions: 'Add game list', 'Exclude game list' and 'Copy roms to folder'

Changes
- Support for nplayers.ini removed (Server is mostly down). All informations are now grabbed from the controls.ini file
- Changed the default controller settings to standard mame/jamma layout

Bugfixes
- Fixed: Wrong game is displayed on lcd after starting a random game
- Fixed: Layout displays sometimes not correct
- Some more small bugs

*******************************************************************************
v1.0 beta3
*******************************************************************************
Improvements
- New application: MalaGamelist: Create and edit game lists and game names
- New application: MalaTree: Create and edit emulator/gamelist trees
- Support for MaLa hardware with 32 leds
- Connect 2 MaLa hardware boards. Up to 64 leds.
- Triggering of leds improved
- Game info window. Displays history, controls, snap, marquee and control panel
- On the fly ipac/jpac programming
- LCD screen for each non mame emulator
- LED state for each non mame emulator
- Attract videos for each non mame emulator
- Use of multiple attract mode files
- Randomized LED attract mode
- Multiple extensions for other emulators
- Auto collect of rom extensions for non mame emulators
- Definable commandline for other emulators with placeholder %rom%
- Change order of other emulators
- Image effects (grayscale, darkness, buttonize)
- Browser mode for gamelist display
- Start game on mala start (selected, random or last played game)
- Jump by letter in gamelists
- Dynamic acceleration of gamelist scrolling
- Sort field per gamelist
- New sort field for gamelist: play count
- Rotating emulator switch
- New lcd and text values: browser flag, browser category, browser filter
- New lcd and text values for emulator view: Background music tag and time values
- New controller option: start random game
- New controller options: vol up, vol down, prev song, next song
- Auto gamelist switch on orientation switch
- Disable splash screen
- Show/Hide windows taskbar
- Mame command line extra parameter
- Support für history.dat file
- New item in MaLa menu 'Game List': browse: on/off
- New items in MaLa menu 'Sound': prev song, next song
- Definables per layout
- MaLaLayout: Resizable main window with scrollbars
- MaLaLayout: Open image dialogs with preview
- MaLaLayout: Preview window for z-order and animations
- MaLaLayout: Lock size and/or position of objects
- Layout: New exit window with selectable default action
- Layout: Background music
- Layout: Z-Order adjustment for all objects
- Layout: 4 new custom images with transparency
- Layout: 4 new animated images/layer with transparency and 4 directions
- Layout: Visibility for title field
- Layout: Default images for snap, marquee and control panel
- New bugs ;-)

Changes
- The gamelist file format has changed: Added controls.ini information to speed up scrolling and extension of romfile
- The gamelist file format has changed: Sort field is now part of gamelist
- The emulator file format has changed: Added video path, lcd screen, led state and ipc file.
- Controller options menu up and menu down removed.
- Node layout removed from MaLa menu

*******************************************************************************
v0.9.9
*******************************************************************************
Improvements
- Mouse support for trackballs, spinners and dials
- Controller detection: rotate and load gamelist on controller movement
- Snap can display cover picture in jukebox mode
- MaLaLayout: Double buffered draw of all windows
- MaLaAttractMode: Double buffered draw of all windows

Changes
- Mouse is hidden by default. Option to hide mouse removed.

*******************************************************************************
v0.9.8a
*******************************************************************************
Improvements
- Double buffered draw of all windows. No flickering anymore.
- Option to disable gui sounds in jukebox mode

*******************************************************************************
v0.9.8
*******************************************************************************
Improvements
- Rotate MaLa in any direction (0, 90, 180, 270)
- Different controller sets particularly for cocktails and 180 degrees screen rotation
- New lcd and text value: time and date
- Rotate MaLa with Mame after quitting game
- Option to search layout images and sounds in MaLa dir or selected dir
- Option to use a directory for images and sounds of each layout
-	Backup and restore complete or parts of MaLa configuration and settings
- MaLaLayout: Function to center objects horizontal and vertical on layout
- MaLaAttractMode: Copy, move, repeat, reverse functions for led states
- MaLaAttractMode: Led state templates

Bugfixes
- No sounds in MaLa menu fixed
- MaLaLayout: Sound for list switch not saved fixed

*******************************************************************************
v0.9.7d
*******************************************************************************
Improvements
- Different image stretch algorithms (speed vs quality)
- New recognized image format: gif
- Text is placed in front of the images now
- Alpha/Index trancparency for images (png, gif, bmp)
- New lcd and text value: emulator name
- MaLaLayout: Transparency switch for each pictureholder

Changes
- Blend transparency for images not available anymore.

*******************************************************************************
v0.9.7c
*******************************************************************************
Bugfix
- Joystick repeat not working fixed

*******************************************************************************
v0.9.7b
*******************************************************************************
Improvements
- Excludes for game collection on main game list refresh (eg Japan, Bootleg, ...)
- Refresh for all mame game lists after updating mame or ini files to a new version

Bugfixes
- Layout switch on MaLa start not working in some cases fixed
- No switch to jukebox if no other emulator is configured fixed

*******************************************************************************
v0.9.7a
*******************************************************************************
Bugfix
- Auto layout switch on gamelists not working fixed

*******************************************************************************
v0.9.7
*******************************************************************************
Improvements
- Jukebox with two modes (gamelist or explorer like)
- LCD screens for the jukebox mode
- Filter sets 
- Scrolling of gamelists optimized. (Fast scrolling funktion)
- Layout switch optimized. Less flicker.
- MaLaLayout: Pattern templates for the textfields
- Layouts for each gamelist (Auto Layout Switch)
- Layout: 8 text holder with placeholders for various values (game, gamelist, controls, mp3 tag, ...)
- Layout: Different GUI sounds for each layout
- Layout: Horizontal and vertical background image for the menu
- Layout: Horizontal and vertical background image for starting dialog
- Layout: Hide text in starting dialog
- Refresh main game list added to mala menu

Changes
- Default layout name for Mame changed to mame.mll (Auto Layout Switch)
- Layout: GameInfo and GameCount fields not available anymore. Use the new text holder instead.
- Menuitems in exit menu renamed (Quit, Shutdown, Reboot)
- GUI tab in options dialog reordered

Bugfixes
- Joystick control in mala menu fixed
- Values not saved in ini file on reboot or shutdown fixed
- Jump to the first game in gamelist after adding or removing games fixed
- Some more bugs fixed

*******************************************************************************
v0.9.6
*******************************************************************************
Improvements
- Support for MaLa hardware with lcd and leds
- Multiple screens with placeholders for the lc display
- Cab attract mode. Light up your buttons.
- Controls.ini support
- 3 rom path values

Bugfixes
- Auto layout switch not working for mame layout when selected from menu fixed
- Top and bottom lines not updated after emu switch fixed
- Definable 4 not ratoted in vertical orientation fixed

*******************************************************************************
v0.9.5b
*******************************************************************************
Improvements
- New sound menu. Playlist and pause on game start added
- Export background music playlist
- Added mame controller to mala controller setup

Bugfixes
- Repeat and shuffle on background music not working fixed
- FadeIn, FadeOut on exit not working fixed
- Gamelist creation: Filter master/clone not enabled fixed

*******************************************************************************
v0.9.5
*******************************************************************************
Improvements
- Background music, controllable via menu (mp3, pls, ...)
- Layout: Choosable amount of lines in game list display
- Layout: 4 picture holder with alternate naming for mame (example: use nplayer info for filenames)
- Layout: 3 pictures for other emulators (added marquee and cpanel holder)
- New filter: master/clone
- Auto game list based on play counter
- Improved atract video handling/loading.
- Rotating lists (lists and games)
- Autorotate mame on orientation switch (edits mame ini)
- Controller settings can be saved
- Game list sort available from menu

Bugfixes
- Remove game from list not working correctly fixed
- Window not in fullscreen mode after orientation switch fixed
- Some more bugs ...


Remarks
The layout format has changed. Old layouts will work, but with wrong colors. Please reedit with MaLaLayout v0.9.5.
The emulator format has changed. Please recreate it if you get some troubles.
All strings used for naming of definable pictures are converted to a filename compatible format and not allowed chars are replaced with a underscore '_'.
Examples: 
'4P alt / 2P sim' -> '4P alt _ 2P sim'
'Tabletop / Mahjong *Mature*' -> 'Tabletop _ Mahjong _Mature_'
'???' -> '___'

*******************************************************************************
v0.9.4
*******************************************************************************
Improvements
- Completely rewritten MalaLayout, now with better handling, faster repaint, ...
- Fixed size layouts for custom/arcade resolutions
- 'Shift' key support. Double your input controls
- Support for attract videos (avi. mpg, wmf)
- New game info advice: players

Bugfixes
- Game list scrolling index error fixed

*******************************************************************************
v0.9.3
*******************************************************************************
Improvements
- Support for non-mame emulators
- Keyboard hook and hotkeys for non-mame emulators
- Auto layout switch on emulator switch (name the layout like the emulator)
- Joystick support to control the gui
- NPlayers.ini file support -> http://nplayers.arcadebelgium.be/
- Antialiased quality for all label displays
- Support for BMP and JPG Snaps, Panels, etc

Bugfixes
- Key repeat value not displayed in edit field
- Alpha sort of layouts in menu
- MaLaLayout: Removed alignment from picture properties

Important!
The format of the game list files has changed.
Please delete and recreate your gamelists. (*.mlg)

*******************************************************************************
v0.9.2
*******************************************************************************
Improvements
- Guided mala/mame configuration process.
- Sounds for controller events.
- Auto run capability

Bugfixes
- Incorrect label display after orientation switch fixed.
- MaLaLayout: Background not selectable fixed.

*******************************************************************************
v0.9.1
*******************************************************************************
Improvements
- Alignment of all Elements added to Layout
- Extra Font Definition for CenterLine in Game List
- MaLaLayout: SendtoBack and BringtoFront

Bugfixes
- After Game playing GUI is not front window. Added BringToFront.
- Crop of Game List Items if to long
- MaLaLayout: Saved layouts wrong extension MLL -> mll
